%ext ck1

###GENERAL###

%version 1.1
%patchfile 0x131F8 savespot.tli

%version 1.31
%patchfile 0x130F8 savespot.tli

#Loading
%patch 0x014F1D "Loading Save Spot!, a Keen 1 mod by Grandy02... (2014) "

#Title position
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4 

#Menu
%patch 0x015EE9 "New Game"
%patch 0x015EF6 "Continue Game"
%patch 0x015F06 "  Story"
%patch 0x015F12 "About Me   "
%patch 0x015F22 "The Keenest"
%patch 0x015F32 "Cameo Hunt!  "
%patch 0x015F44 "Pictures!"
%patch 0x015F44 "Mod Info "
%patch 0x015F52 "Title Screen"

###PALETTE###

# The four palettes used when fading, from darkest to lightest. 
# The second one is also used when the light switch is off 
# The first one is all black
%patch $15558  $00 $00 $00 $00 $00 $00 $00 $00  $00 $00 $00 $00 $00 $00 $00 $00 
%patch $15569  $00 $00 $00 $00 $00 $00 $00 $00  $00 $01 $02 $03 $04 $05 $06 $07 
%patch $1557A  $00 $00 $00 $00 $00 $00 $00 $00  $18 $19 $1A $1B $1C $1D $1E $1F 
%patch $1558B  $00 $01 $02 $03 $04 $05 $06 $07  $18 $19 $1A $1B $1C $1D $1E $1F 

# This is the color palette: 16 entries of r, g, b (each 0-63) 
%patch $13054 
       00 00 00 # black 
       00 00 42 # blue 
       00 42 00 # green 
       00 42 42 # cyan 
       42 00 00 # red 
       42 00 42 # magenta 
       42 21 00 # brown 
       42 42 42 # bright gray 
       21 21 21 # gray 
       21 21 63 # bright blue 
       21 63 21 # bright green 
       21 55 63 # bright cyan 
       63 21 21 # bright red 
       63 21 63 # pink 
       63 63 21 # yellow 
       63 63 63 # white 
# Set the palette when we go into graphics mode 
%patch $6E46  $E8 $D3 $D5 $90 $90 
# Code to set graphics mode and set the palette 
%patch $441C                  $B8 $0D $00 $CD 
              $10 $B8 $12 $10 $B9 $08 $00 $BB 
              $00 $00 $8C $DA $8E $C2 $BA $04 
              $00 $CD $10 $BB $18 $00 $BA $1C 
              $00 $CD $10 $C3 

###TEXT SCREENS###

# About ID Screen
%patch 0x00015f80 "Grandy02 is a German Keen fan who "
%patch 0x00015fa8 "enjoys the Commander Keen series "
%patch 0x00015fd0 "since his childhood. It began "
%patch 0x00015ff8 "with Keen Dreams.   "
%patch 0x00016020 "In 2004 I learned about modding "
%patch 0x00016048 "and the community in general.      "
%patch 0x00016070 "Development of Save Spot! "
%patch 0x00016098 "started in late 2004.  "
%patch 0x000160c0 "After many long breaks, I've "
%patch 0x000160e8 "finally released my mod. I hope  "
%patch 0x00016110 "you'll enjoy it! :-)     "

#Ordering Info text
%patch $1632C         "In this mod, I've hidden" $0A $00
%patch $16346         "18 community cameos. Each" $0A $00
%patch $16361         "one is a reference to " $0A $00
%patch $16379         "a certain Keener. In   " $0A $00
%patch $16392         "most cases it is a single" $0A $00
%patch $163AD         "tile related to one of   " $0A $00
%patch $163C8         "their works or an avatar." $0A $00
%patch $163E3  "                                      " $0A $00
%patch $1640B "  They are some cameos you will just " $0A $00
%patch $16432 "  stumble into. But the others are   " $0A $00
%patch $16459 "  not that easy to find. Keep an   " $0A $00
%patch $1647E "  eye on the level borders..." $0A $0A $00

%patch $1649E "                                      " $0A $00
%patch $164C6 "Can you find           Visit the Keen " $0A $00
%patch $164EE "them all?              Community at   " $0A $00
%patch $16516 "Good luck!             www.pckf.com     " $0A $0A $0A $00

%patch $16542 "  Thanks to all the great Keeners who   " $0A $00
%patch $16570 "  keep the Commander Keen saga alive!   " $0A $00


###STATUS WINDOW###

#Big versatile status window patch:
#Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

#Status text file
%patch $13084  "STATUS.CK1" $00 

#Draw the status window
#Draw window of size 27x0A
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00 
               $CD $21 $89 $C3 $BF $0027W  $C6 $06 $9A $82 $00 $B9 $000AW  $BA
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21

#Draw extra Keen score at 01,0A
%patch $0E98                               $8B $46 $FE $05 $0001W  $50 $89 
               $F0 $05 $000AW  $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03
               $83 $C4 $08 

#Draw extra Keen score at 01,1A
%patch $0EB3               $8B $46 $FE $05 $0001W  $50 $89 $F0 $05 $001AW  $50
               $A1 $C4 $6E $8B $16 $C2 $6E $81 $C2 $20 $4E $15 $00 $00 $50 $52
               $E8 $E1 $02 $83 $C4 $08

#Draw Keen's lives, count $AAC6W, show sprite $007B \ 4 at 03,01 
%patch $0ED6                           $31 $FF $3B $3E $AAC6W  $7D $29 $83 $FF
               $06 $7D $24 $B8 $007BW  $50 $8B $46 $FE $05 $0003W  $B1 $03 $D3
               $E0 $90 $90 $50 $89 $F8 $D1 $E0 $05 $0001W  $01 $F0 $50 $E8 $2C
               $AC $83 $C4 $06 $47 $EB $D1

#Draw joystick, check $AA94, if 0 show tile $0141 else show tile $01C0 at position 3.5 (3 + 4 pixels),10
%patch $0F07                               $B8 $0141W  $83 $3E $AA94W  $00 $74
               $03 $B8 $01C0W  $50 $8B $46 $FE $05 $0003W  $B1 $03 $D3 $E0 $05
               $0004W  $50 $89 $F0 $05 $0010W  $50 $E8 $0D $AA $83 $C4 $06

#Draw battery, check $AA9C, if 0 show tile $0142 else show tile $01C1 at position 3.5,13
                                                                           $B8   # Draw the battery 
               $0142W  $83 $3E $AA9CW  $00 $74 $03 $B8 $01C1W  $50 $8B $46 $FE 
               $05 $0003W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0013W
               $50 $E8 $E5 $A9 $83 $C4 $06

#Draw vacuum, check $AA96, if 0 show tile $0143 else show tile $01C2 at position 3.5,16
                                           $B8 $0143W  $83 $3E $AA96W  $00 $74 
               $03 $B8 $01C2W  $50 $8B $46 $FE $05 $0003W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0016W  $50 $E8 $BD $A9 $83 $C4 $06

#Draw whiskey, check $AA98, if 0 show tile $0144 else show tile $01C3 at position 3.5,19
                                                                           $B8
               $0144W  $83 $3E $AA98W  $00 $74 $03 $B8 $01C3W  $50 $8B $46 $FE 
               $05 $0003W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0019W
               $50 $E8 $95 $A9 $83 $C4 $06

#Draw Key A, check $AA9E, if 0 show tile $0225 else show tile $01A8 at position 7.5,13
%patch $0FA7                               $B8 $0225W  $83 $3E $AA9EW  $00 $74
               $03 $B8 $01A8W  $50 $8B $46 $FE $05 $0007W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0013W  $50 $E8 $6D $A9 $83 $C4 $06

#Draw Key B, check $AAA0, if 0 show tile $0225 else show tile $01A9 at position 7.5,17
                                                                           $B8
               $0225W  $83 $3E $AAA0W  $00 $74 $03 $B8 $01A9W  $50 $8B $46 $FE 
               $05 $0007W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0017W
               $50 $E8 $45 $A9 $83 $C4 $06

#Draw Key C, check $AAA2, if 0 show tile $0225 else show tile $01AA at position 9.5,13
                                           $B8 $0225W  $83 $3E $AAA2W  $00 $74
               $03 $B8 $01AAW  $50 $8B $46 $FE $05 $0009W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $0013W  $50 $E8 $1D $A9 $83 $C4 $06

#Draw Key D, check $AAA4, if 0 show tile $0225 else show tile $01AB at position 9.5,17
                                                                           $B8
               $0225W  $83 $3E $AAA4W  $00 $74 $03 $B8 $01ABW  $50 $8B $46 $FE 
               $05 $0009W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0017W 
               $50 $E8 $F5 $A8 $83 $C4 $06

#Draw Pogo, check $AA9A, if 0 show tile $000B else show tile $019F at position 8.5,0B
%patch $1047                               $B8 $000BW  $83 $3E $AA9AW  $00 $74
               $03 $B8 $019FW  $50 $8B $46 $FE $05 $0008W  $B1 $03 $D3 $E0 $05 
               $0004W  $50 $89 $F0 $05 $000BW  $50 $E8 $CD $A8 $83 $C4 $06

#Draw Ammo value, count $AAC8, at position 0B,05
                                                                           $8B
               $46 $FE $05 $000BW  $50 $89 $F0 $05 $0005W  $50 $31 $C0 $50 $FF 
               $36 $AAC8W  $E8 $2E $01 $83 $C4 $08

#Draw Raygun at position 7.5,03 (Change first two bytes to $EB $1C to skip)
                                                   $B8 $019EW  $50 $8B $46 $FE
               $05 $0007W  $B1 $03 $D3 $E0 $05 $0004W  $50 $89 $F0 $05 $0003W
               $50 $E8 $95 $A8 $83 $C4 $06

#Wait for key and return
                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3

###SPRITES###

#Height of Keen's shot
%patch $46DC $10

#Hits to kill Vorticon
%patch $180D $02 $00

#Hits to kill Vorticon Commander
%patch $1819 $02 $00

#Keen and Garg are the same size
%patch $1B8B $00

#Slow down Tank's walking animation speed
%patch $1ED2 $02

#Chain killed by Keen on touch
%patch $22C7 $3F $01

#Chain doesn't kill Vorticons when shot
%patch $234C $5F $5E $5D $C3

#Falling block moves to the right
%patch $24DC $00
%patch $24DD $01

#Number of tiles the block falls
%patch $24E8 $44

#Icecube smash sound
%patch $229A $25

###ITEMS###

#Ship Parts levels (Part removed if you die in this level)
%patch $4F75 $0003W $74 #Joystick
%patch $4F70 $0007W $74 #Battery
%patch $4F69 $000DW $74 #Vacuum
%patch $4F7C $000EW $74 #Whiskey

#Always have Pogo
%patch $900E $01 $00 

#Lollipop points
%patch $15078 $32 $00

#Pizza points
%patch $15076 $012CW

#Keen 3 scoring items backgrounds
%patch $4409      $26 $8B $07 $B6 $0D $F6 $FE 
%patch $4410  $F6 $EE $26 $89 $07 $E9 $60 $01 

%patch $4482  $E9 $74 $FF 
%patch $44BA  $E9 $3C $FF 
%patch $4513  $E9 $E3 $FE 

%patch $28EC                  $26 $8B $07 $B6 
%patch $28F0  $0D $F6 $FE $F6 $EE $26 $89 $07 
%patch $28F8  $03 $1E $08 $6C $03 $1E $08 $6C 
%patch $2900  $26 $89 $07 $90 $90 $90 $90 $90 

###TILE-RELATED###

#Falling block tiles
%patch $23CD $008FW #Top left
%patch $23EF $008FW #Bottom left
%patch $24D8 $01EAW #Bottom right
%patch $23AB $008FW #Left left behind
%patch $2414 $008FW #Middle left behind
%patch $2494 $008FW #Right left behind

#Bridge block
%patch $4AEE $09 $01
%patch $4B3D $09 $01

#Change tile Yorp message head becomes
%patch $455E $B1 $01
#And Garg
%patch $4547 $3B $01

#Animating switch
%patch $36DB $1C $01 #This tile when flipped becomes...
%patch $36E0 $1D $01 #This tile and...
%patch $36FC $1D $01 #This tile when flipped becomes...
%patch $3716 $1C $01 #This tile.

#Change high score table item tiles
%patch $992A  $EB $00 #Joystick
%patch $995D  $ED $00 #Battery 
%patch $9990  $EF $00 #Vacuum 
%patch $99C3  $F1 $00 #Everclear

#Stop the high score items animating 
%patch $9929 $B8 #Joystick
%patch $995C $B8 #Battery
%patch $998F $B8 #Vacuum
%patch $99C2 $B8 #Everclear

#Make the door act like a wall when moving right
%patch $2F31  $E8 $9D $E1 $90 $90
#Make the door act like a wall when moving left
%patch $2FE6  $E8 $0B $E1 $90 $90

#Here's where the real work is done
%patch $10D1  $81 $3E $54 $82 $C4 $45 $75 $15
              $8B $87 $6E $05 $48 $48 $3D $04
              $00 $73 $0A $89 $C3 $D1 $E3 $83
              $BF $9E $AA $01 $C3 $83 $BF $86
              $18 $00 $C3 $81 $3E $54 $82 $C4
              $45 $75 $15 $8B $87 $6E $05 $48
              $48 $3D $04 $00 $73 $0A $89 $C3
              $D1 $E3 $83 $BF $9E $AA $01 $C3
              $83 $BF $FA $0E $00 $C3

#Stop the door bouncing
%patch $43A4  $E9 $D1 $01

###MAP###

#Change the teleporter locations
#Location 1 (17,25)
%patch $158DF $0110W
%patch $158E3 $0190W

#Location 2 (24, 26)
%patch $158E9 $0180W
%patch $158ED $01A0W

#Location 3 (50,87)
%patch $158F3 $0370W
%patch $158F7 $0520W

#Flag-done tiles patch:
%patch $7C07  $83 $EC $20 
%patch $7D13              $31 $F6 $C4 $3E $4C $6C $8B $16 $08 $6C $A1 $58 $6C 
%patch $7D20  $F7 $E2 $89 $C1 $09 $C9 $75 $03 $E9 $DA $00 $26 $8B $05 $C7 $46 
%patch $7D30  $E0 $00 $00 $A9 $00 $80 $74 $05 $C7 $46 $E0 $01 $00 $25 $FF $7F 
%patch $7D40  $75 $03 $E9 $B9 $00 $89 $46 $FC $3D $10 $00 $7C $03 $E9 $85 $00 
%patch $7D50  $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $75 $03 $E9 $A0 $00 $26 $C7 
%patch $7D60  $05 $00 $00 $83 $7E $E0 $00 $74 $03 $E9 $92 $00 $89 $FB $43 $43 
%patch $7D70  $26 $8B $07 $25 $FF $7F $3B $46 $FC $75 $47 $26 $C7 $07 $00 $00 
%patch $7D80  $03 $1E $08 $6C $03 $1E $08 $6C $26 $C7 $07 $00 $00 $4B $4B $26 
%patch $7D90  $C7 $07 $00 $00 $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 
%patch $7DA0  $C7 $07 $004EW  $43 $43 $26 $C7 $07 $004FW  $03 $1E $08 $6C $03 
%patch $7DB0  $1E $08 $6C $26 $C7 $07 $0051W  $4B $4B $26 $C7 $07 $0050W  $07 
%patch $7DC0  $EB $3C $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07 
%patch $7DD0  $004DW  $07 $EB $29 $3D $65 $00 $7C $24 $3D $74 $00 $7F $1F $2D 
%patch $7DE0  $64 $00 $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $74 $11 $06 $C4 $1E 
%patch $7DF0  $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07 $0053W  $07 $49 $47 
%patch $7E00  $47 $46 $E9 $1F $FF $EB $4A

###TEXT MESSAGES###

#BwB on map
%patch $1659B "You can't leave now." $0A "Save Spot!  " $0A $0A $0A $0A $0A $00
%patch $165C2 "Find all items! " $0A $00
%patch $165D4 "Press any " $00
%patch $165E0 "key:" $00
%patch $165E5 "button:" $00

# cheat messages
%patch 0x014DEE "Okay, you just got   "
%patch 0x014E05 "all the gems and none less"
%patch 0x014E21 "than 100 charges, you "
%patch 0x014E39 "little cheater, you.    "

%patch 0x014F07 "Bad conscience?!?"

%level.hint 11
Mortimer says:      
You have come here  
because of that     
stupid thing? Haha. 

%level.hint 2
The sign reads:     
                    
For finding a hidden
place, you must not 
be afraid of holes. 
And do not fear     
spikes, either.     

%level.hint 6
Keen reads the sign:
                    
One of the under-   
world tunnels in the
northeast will lead 
you to a secret     
place in the south. 

%level.hint 9
It is written:      
                    
Be aware that the   
transport platform  
is a prototype.     
Standing on it could
be quite difficult. 

%level.hint 10
Keen reads this:    
                    
Follow the finger of
the stone man. Keep 
that direction until
the end to reach the
secret teleport.    

%level.hint 12
Mortimer wrote this!
                    
Your pet's intellect
is far behind your's.
So why do you care? 
You all don't       
deserve to live!    

%level.hint 15
Someone wrote:      
                    
Don't forget to take
the green gem high  
up in the tree for  
finding the secret. 

###FINALE - MAP###

#Level used for ending map
%patch $81CA  82

#Ending map position
%patch $81D7 $30     #x position (x10)
%patch $81DD $00     #x position
%patch $81E3 $E0     #Y position (x10)
%patch $81E8 $01     #Y position

#Don't show Keen on the map ending sequence
%patch $8203 $90 $90 $90

#Back on Mars message
%patch $15C24 "Commander Keen returns to the small" $0A $00
%patch $15C49 "shrine and quickly uses the four " $0A $00
%patch $15C6C "items to free Spot from his prison." $0A $00
%patch $15C91 "The two friends hug each other." $00

###FINALE - KEEN's HOUSE###

#Finale Textbox 1 location
%patch $8546 $04 #Bottom
%patch $854E $00 #Top

#Finale Textbox 2 location
%patch $85D5 $04 #Bottom
%patch $85DD $00 #Top

#Finale Textbox 3 location
%patch $8635 $05 #Bottom
%patch $863D $00 #Top

#Finale Textbox 4 location
%patch $867B $03 #Bottom
%patch $8683 $00 #Top

#Finale Textbox 5 location
%patch $86AF $04 #Bottom
%patch $86B7 $00 #Top

#Finale Textbox 6 location
%patch $86EC $02 #Bottom
%patch $86F4 $00 #Top

#Finale Textbox 7 location
%patch $8714 $02 #Bottom
%patch $871C $00 #Top

#Finale Textbox 8 location
%patch $877C $06 #Bottom
%patch $8784 $00 #Top


#Finale Text 1
%patch $15CBD "Once again, Keen has  " $0A $00
%patch $15CD5 "thwarted the plans" $0A $00
%patch $15CE9 "of evil Mortimer!" $00

%patch $8599 $90 $90 $90 #Don't show bitmap
%patch $85A3 $90 $90 $90 #Don't play sound

%patch $85BC $90 $90 $90 #Don't show bitmap
%patch $85C3 $00 #Sound played

%patch $85A9 $0004W #Pause before next bitmap appears 
%patch $85CC $0004W #Pause before second textbox appears

#Finale Text 2
%patch $15CFB "Most importantly,  " $0A $00
%patch $15D10 "Billy and Spot are " $0A $00
%patch $15D25 "reunited. " $00

#Finale Text 3
%patch $15D30 "They are ready to... " $0A $00
%patch $15D47 "SUDDENLY, MORT'S FACE" $0A $00 #Text jump
%patch $15D5E "APPEARS ON THAT    " $0A $00
%patch $15D73 "SCREEN!!!!!" $00

#Finale Text 4
%patch $15D80 "So, you again,  " $0A $00
%patch $15D92 "Mr. 314? " $00

#Finale Text 5
%patch $15D9C "You've nothing better " $0A $00
%patch $15DB4 "to do than to ruin  " $0A $00
%patch $15DCA "my wicked plans, huh?! " $00

#Finale Text 6
%patch $15DE2 "But next time...   " $00

#Finale Text 7
%patch $15DF6 "YOU'RE DOOMED!! " $00

%patch $8759 $23 #Sound played

#Finale Text 8
%patch $15E07 "But Keen and Spot    " $0A $00
%patch $15E1E "are not impressed by   " $0A $00
%patch $15E37 "Mortimer's threats." $0A $00
%patch $15E4C "They're glad and will" $0A $00
%patch $15E63 "return home.  " $00

%patch $876B $0B #Bitmap used (test card)
%patch $8795 $90 $90 $90 #Don't play sound

#End Text
%patch $15E72 "    ~~THE END~~    " $00


%end